/* Modulo rubrica, derivato da gnome-propertybox
*/

#ifndef __MODULO_RUBRICA_H
#define __MODULO_RUBRICA_H

#include <libgnomeui/gnome-dialog.h>
#include <libgnome/gnome-defs.h>
#include "rubrica.h"

BEGIN_GNOME_DECLS

#define MODULO_RUBRICA_TYPE            (modulo_rubrica_get_type())
#define MODULO_RUBRICA(obj)            (GTK_CHECK_CAST((obj), MODULO_RUBRICA_TYPE, ModuloRubrica))
#define MODULO_RUBRICA_CLASS(klass)    (GTK_CHECK_CLASS_CAST((klass), MODULO_RUBRICA_TYPE, ModuloRubricaClass))
#define IS_MODULO_RUBRICA(obj)         (GTK_CHECK_TYPE((obj), MODULO_RUBRICA_TYPE))
#define IS_MODULO_RUBRICA_CLASS(klass) (GTK_CHECK_CLASS_TYPE((klass), MODULO_RUBRICA_TYPE))


/* flag utilizzato nelle pagine del notebook per verificare se
   sono avvenute delle modifiche
*/
#define MODULO_MODIFICATO      "modulo_rubrica_modificato"

typedef struct _ModuloRubrica         ModuloRubrica;
typedef struct _ModuloRubricaClass    ModuloRubricaClass;

struct _ModuloRubrica {
  GnomeDialog dialog;

  /* il notebook */
  GtkWidget *notebook;       

  /* elementi del frame dati */
  /* i toogle button */
  GtkWidget *editabile;
  GtkWidget *cancellabile;

  /* entry */
  GtkWidget *scheda;

  GtkWidget *nome;
  GtkWidget *cognome;
  GtkWidget *professione;

  GtkWidget *via;
  GtkWidget *numero;
  GtkWidget *cap;
  GtkWidget *citta;
  GtkWidget *provincia;
  GtkWidget *stato;
  /* ------------------------------ */


  /* elementi del frame rete */
  /* entry */
  GtkWidget *web;
  GtkWidget *mail;

  /* clist */
  GtkWidget *clist_web;
  GtkWidget *clist_mail;

  /* bottoni web, mail */
  GtkWidget *web_aggiungi;
  GtkWidget *web_modifica;
  GtkWidget *web_cancella;

  GtkWidget *mail_aggiungi;
  GtkWidget *mail_modifica;
  GtkWidget *mail_cancella;
  /* ------------------------------ */

  
  /* elementi del frame telefono */
  /* entry */
  GtkWidget *telefono;  
  
  /* tipo telefono */
  GtkWidget *tipo_telefono;

  GSList *tabella_tipo_group; // = NULL;
  
  /* radio buttons */
  GtkWidget *radio_casa;
  GtkWidget *radio_ufficio;
  GtkWidget *radio_fax;
  GtkWidget *radio_cellulare;

  /* bottoni telefono */
  GtkWidget *telefono_aggiungi;
  GtkWidget *telefono_modifica;
  GtkWidget *telefono_cancella;

  /* clist */
  GtkWidget *clist_telefono;
  /* ------------------------------ */


  /* elementi del frame note */
  /* text */
  GtkWidget *note;
  /* ------------------------------ */


  /* i bottoni principali del widget modulo */
  GtkWidget *ok;
  GtkWidget *applica;
  GtkWidget *cancella;
  GtkWidget *aiuto;  // definito ma da utilizzare in futuro
};


struct _ModuloRubricaClass {
  GnomeDialogClass parent_class;

  void (* applica) (ModuloRubrica *modulo, gint pagina);
  void (* aiuto)   (ModuloRubrica *modulo, gint pagina);
};


guint modulo_rubrica_get_type (void);
GtkWidget *modulo_rubrica_new (void);  

/* 
   funzioni richiamate quando il contenuto del modulo cambia 
*/
void modulo_rubrica_changed      (ModuloRubrica *modulo);
void modulo_rubrica_set_modified (ModuloRubrica *modulo, gboolean stato);

/*
gint modulo_rubrica_nuova_pagina (ModuloRubrica *modulo, GtkWidget *child, 
				  GtkWidget *label);
*/

/* 
   funzioni richiamate quando si vuole inserire un nuovo elemento
   o modificare un elemento esistente
*/
guint modulo_rubrica_modifica_elemento     (Rubrica **rub);
Rubrica *modulo_rubrica_inserisci_elemento (void);

END_GNOME_DECLS

#endif
